#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SearchCheckAlertsSortField {
    #[serde(rename = "CHECK_NAME")]
    CheckName,
    #[serde(rename = "START")]
    Start,
    #[serde(rename = "END")]
    End,
    #[serde(rename = "STATUS")]
    Status,
    #[serde(rename = "PRIORITY")]
    Priority,
    #[serde(rename = "DURATION")]
    Duration,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SearchCheckAlertsSortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SearchCheckAlertsSortField::CheckName => "CHECK_NAME",
            SearchCheckAlertsSortField::Start => "START",
            SearchCheckAlertsSortField::End => "END",
            SearchCheckAlertsSortField::Status => "STATUS",
            SearchCheckAlertsSortField::Priority => "PRIORITY",
            SearchCheckAlertsSortField::Duration => "DURATION",
            SearchCheckAlertsSortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SearchCheckAlertsSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SearchCheckAlertsSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SearchCheckAlertsSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SearchCheckAlertsSortField, conjure_object::plain::ParseEnumError> {
        match v {
            "CHECK_NAME" => Ok(SearchCheckAlertsSortField::CheckName),
            "START" => Ok(SearchCheckAlertsSortField::Start),
            "END" => Ok(SearchCheckAlertsSortField::End),
            "STATUS" => Ok(SearchCheckAlertsSortField::Status),
            "PRIORITY" => Ok(SearchCheckAlertsSortField::Priority),
            "DURATION" => Ok(SearchCheckAlertsSortField::Duration),
            v => v.parse().map(|v| SearchCheckAlertsSortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SearchCheckAlertsSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SearchCheckAlertsSortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SearchCheckAlertsSortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
